From: Christoph Hellwig <hch@lst.de>
To: Zorro Lang <zlang@kernel.org>
Cc: Anand Jain <asj@kernel.org>, Filipe Manana <fdmanana@suse.com>,
"Darrick J. Wong" <djwong@kernel.org>,
fstests@vger.kernel.org, linux-ext4@vger.kernel.org,
linux-xfs@vger.kernel.org
Subject: [PATCH 12/13] xfs/530: require a real SCRATCH_RTDEV
Date: Fri, 12 Dec 2025 09:22:00 +0100 [thread overview]
Message-ID: <20251212082210.23401-13-hch@lst.de> (raw)
In-Reply-To: <20251212082210.23401-1-hch@lst.de>
Require a real SCRATCH_RTDEV instead of faking one up using a loop
device, as otherwise the options specified in MKFS_OPTIONS might
not actually work the configuration.
Note that specifying a rtextsize doesn't work for zoned file systems,
so _notrun when mkfs fails.
Signed-off-by: Christoph Hellwig <hch@lst.de>
---
tests/xfs/530 | 42 +++++++++++++-----------------------------
tests/xfs/530.out | 1 -
2 files changed, 13 insertions(+), 30 deletions(-)
diff --git a/tests/xfs/530 b/tests/xfs/530
index 4a41127e3b82..ffc9e902e1b7 100755
--- a/tests/xfs/530
+++ b/tests/xfs/530
@@ -10,36 +10,22 @@
. ./common/preamble
_begin_fstest auto quick realtime growfs
-# Override the default cleanup function.
-_cleanup()
-{
- cd /
- _scratch_unmount >> $seqres.full 2>&1
- [ -n "$rt_loop_dev" ] && _destroy_loop_device $rt_loop_dev
- rm -f $tmp.* $TEST_DIR/$seq.rtvol
-}
-
-# Import common functions.
. ./common/filter
. ./common/inject
. ./common/populate
-
-# Note that we don't _require_realtime because we synthesize a rt volume
-# below.
-_require_test
+_require_scratch
+_require_realtime
_require_xfs_debug
_require_test_program "punch-alternating"
_require_xfs_io_error_injection "reduce_max_iextents"
_require_xfs_io_error_injection "bmap_alloc_minlen_extent"
-_require_scratch_nocheck
echo "* Test extending rt inodes"
_scratch_mkfs | _filter_mkfs >> $seqres.full 2> $tmp.mkfs
. $tmp.mkfs
-echo "Create fake rt volume"
nr_bitmap_blks=25
nr_bits=$((nr_bitmap_blks * dbsize * 8))
@@ -50,17 +36,12 @@ else
rtextsz=$dbsize
fi
-rtdevsz=$((nr_bits * rtextsz))
-truncate -s $rtdevsz $TEST_DIR/$seq.rtvol
-rt_loop_dev=$(_create_loop_device $TEST_DIR/$seq.rtvol)
-
echo "Format and mount rt volume"
-
-export USE_EXTERNAL=yes
-export SCRATCH_RTDEV=$rt_loop_dev
-_scratch_mkfs -d size=$((1024 * 1024 * 1024)) \
- -r size=${rtextsz},extsize=${rtextsz} >> $seqres.full
-_try_scratch_mount || _notrun "Couldn't mount fs with synthetic rt volume"
+_try_scratch_mkfs_xfs \
+ -d size=$((1024 * 1024 * 1024)) \
+ -r size=${rtextsz},extsize=${rtextsz} >> $seqres.full 2>&1 || \
+ _notrun "Couldn't created crafted fs (zoned?)"
+_try_scratch_mount || _notrun "Couldn't mount crafted fs"
# If we didn't get the desired realtime volume and the same blocksize as the
# first format (which we used to compute a specific rt geometry), skip the
@@ -92,7 +73,12 @@ echo "Inject bmap_alloc_minlen_extent error tag"
_scratch_inject_error bmap_alloc_minlen_extent 1
echo "Grow realtime volume"
-$XFS_GROWFS_PROG -r $SCRATCH_MNT >> $seqres.full 2>&1
+# growfs expects sizes in FSB units
+fsbsize=$(_get_block_size $SCRATCH_MNT)
+rtdevsz=$((nr_bits * rtextsz))
+
+$XFS_GROWFS_PROG -R $((rtdevsize / fsbsize)) $SCRATCH_MNT \
+ >> $seqres.full 2>&1
if [[ $? == 0 ]]; then
echo "Growfs succeeded; should have failed."
exit 1
@@ -115,8 +101,6 @@ echo "Check filesystem"
_check_scratch_fs
_scratch_unmount &> /dev/null
-_destroy_loop_device $rt_loop_dev
-unset rt_loop_dev
# success, all done
status=0
diff --git a/tests/xfs/530.out b/tests/xfs/530.out
index 6ddb572f9435..3c508b4564f7 100644
--- a/tests/xfs/530.out
+++ b/tests/xfs/530.out
@@ -1,6 +1,5 @@
QA output created by 530
* Test extending rt inodes
-Create fake rt volume
Format and mount rt volume
Consume free space
Create fragmented filesystem
--
2.47.3
next prev parent reply other threads:[~2025-12-12 8:23 UTC|newest]
Thread overview: 29+ messages / expand[flat|nested] mbox.gz Atom feed top
2025-12-12 8:21 stop overriding SCRATCH_{,LOG,RT}DEV v2 Christoph Hellwig
2025-12-12 8:21 ` [PATCH 01/13] dmflakey: override SCRATCH_DEV in _init_flakey Christoph Hellwig
2025-12-12 20:11 ` Darrick J. Wong
2025-12-15 5:29 ` Christoph Hellwig
2025-12-15 19:41 ` Darrick J. Wong
2025-12-17 16:59 ` Anand Jain
2025-12-12 8:21 ` [PATCH 02/13] ext4/006: call e2fsck directly Christoph Hellwig
2025-12-12 20:02 ` Darrick J. Wong
2025-12-15 5:27 ` Christoph Hellwig
2025-12-15 19:42 ` Darrick J. Wong
2025-12-17 17:01 ` Anand Jain
2025-12-12 8:21 ` [PATCH 03/13] common: add a _check_dev_fs helper Christoph Hellwig
2025-12-17 17:01 ` Anand Jain
2025-12-12 8:21 ` [PATCH 04/13] ext4/032: use _check_dev_fs Christoph Hellwig
2025-12-17 17:02 ` Anand Jain
2025-12-12 8:21 ` [PATCH 05/13] generic/590: split XFS RT specific bits out Christoph Hellwig
2025-12-17 17:02 ` Anand Jain
2025-12-12 8:21 ` [PATCH 06/13] xfs/157: don't override SCRATCH_{,LOG,RT}DEV Christoph Hellwig
2025-12-12 8:21 ` [PATCH 07/13] xfs/185: don't use SCRATCH_{,RT}DEV helpers Christoph Hellwig
2025-12-12 8:21 ` [PATCH 08/13] xfs/424: don't use SCRATCH_DEV helpers Christoph Hellwig
2025-12-12 8:21 ` [PATCH 09/13] xfs/521: require a real SCRATCH_RTDEV Christoph Hellwig
2025-12-12 8:21 ` [PATCH 10/13] xfs/521: call _require_scratch_size Christoph Hellwig
2025-12-12 20:01 ` Darrick J. Wong
2025-12-12 8:21 ` [PATCH 11/13] xfs/528: require a real SCRATCH_RTDEV Christoph Hellwig
2025-12-12 20:00 ` Darrick J. Wong
2025-12-12 8:22 ` Christoph Hellwig [this message]
2025-12-12 20:00 ` [PATCH 12/13] xfs/530: " Darrick J. Wong
2025-12-12 8:22 ` [PATCH 13/13] xfs/650: " Christoph Hellwig
-- strict thread matches above, loose matches on Subject: below --
2025-12-18 7:29 stop overriding SCRATCH_{,LOG,RT}DEV v3 Christoph Hellwig
2025-12-18 7:30 ` [PATCH 12/13] xfs/530: require a real SCRATCH_RTDEV Christoph Hellwig
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20251212082210.23401-13-hch@lst.de \
--to=hch@lst.de \
--cc=asj@kernel.org \
--cc=djwong@kernel.org \
--cc=fdmanana@suse.com \
--cc=fstests@vger.kernel.org \
--cc=linux-ext4@vger.kernel.org \
--cc=linux-xfs@vger.kernel.org \
--cc=zlang@kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox